/*
  $Id: MessageLevel.java,v 1.4 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.application;

/**
 * \brief An enumeration to control different types of errors
 * <br>
 * NFO : info level<br>
 * WRN : report a warning<br>
 * ERR : report an error that does not impact current state of type checker : type checking can continue<br>
 * ERR_EXP : report an error during type checking of expression : the type checker internal state is impacted. type checking of this expression must be stopped.
 * ERR_FNT : report an error that impact type checking of the whole method : type checking of this method cannot continue
 * ERR_FAT : internal error : the compiler must abort the compilation
 */

public class MessageLevel
{
  public static final MessageLevel NFO = new MessageLevel(0);
  public static final MessageLevel WRN = new MessageLevel(1);
  public static final MessageLevel ERR = new MessageLevel(2);
  public static final MessageLevel DBG = new MessageLevel(3);

  private int level;
  private MessageLevel(int level) { this.level = level; }
}