/*
  $Id: NativeTypes.java,v 1.5 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.application;

import net.nosica.parser.node.util.var.TypeName;
import net.nosica.parser.node.util.var.TypeNameImpl;
import net.nosica.parser.node.util.var.TypeNameComponent;
import net.nosica.parser.node.util.var.TypeNameComponentImpl;

import java.util.ArrayList;

public class NativeTypes
{
  // some usefull constants
  private static TypeName net_nosica_lang;
  private static TypeName net_nosica_lang_Object;
  private static TypeName net_nosica_lang_General;
  private static TypeName net_nosica_lang_int8;
  private static TypeName net_nosica_lang_int16;
  private static TypeName int_;
  private static TypeName net_nosica_lang_int32;
  private static TypeName net_nosica_lang_int64;
  private static TypeName net_nosica_lang_word8;
  private static TypeName net_nosica_lang_word16;
  private static TypeName word;
  private static TypeName net_nosica_lang_word32;
  private static TypeName net_nosica_lang_word64;
  private static TypeName float_;
  private static TypeName net_nosica_lang_float32;
  private static TypeName net_nosica_lang_float64;
  private static TypeName net_nosica_lang_char;
  private static TypeName net_nosica_lang_char_array;
  private static TypeName net_nosica_lang_string;
  private static TypeName net_nosica_lang_string_array;
  private static TypeName net_nosica_lang_Array;
  private static TypeName net_nosica_lang_bool;
  private static TypeName net_nosica_lang_None;
  private static TypeName net_nosica_lang_Exception;
  private static TypeName net_nosica_lang_Throwable;
  private static TypeName net_nosica_lang_RuntimeException;

  public static TypeName get_net_nosica_lang() { return net_nosica_lang; }
  public static TypeName get_net_nosica_lang_Object() { return net_nosica_lang_Object; }
  public static TypeName get_net_nosica_lang_General() { return net_nosica_lang_General; }

  public static TypeName get_net_nosica_lang_int8() { return net_nosica_lang_int8; }
  public static TypeName get_net_nosica_lang_int16() { return net_nosica_lang_int16; }
  public static TypeName get_int() { return int_; }
  public static TypeName get_net_nosica_lang_int32() { return net_nosica_lang_int32; }
  public static TypeName get_net_nosica_lang_int64() { return net_nosica_lang_int64; }

  public static TypeName get_net_nosica_lang_word8() { return net_nosica_lang_word8; }
  public static TypeName get_net_nosica_lang_word16() { return net_nosica_lang_word16; }
  public static TypeName get_word() { return word; }
  public static TypeName get_net_nosica_lang_word32() { return net_nosica_lang_word32; }
  public static TypeName get_net_nosica_lang_word64() { return net_nosica_lang_word64; }

  public static TypeName get_float() { return float_; }
  public static TypeName get_net_nosica_lang_float32() { return net_nosica_lang_float32; }
  public static TypeName get_net_nosica_lang_float64() { return net_nosica_lang_float64; }

  public static TypeName get_net_nosica_lang_char() { return net_nosica_lang_char; }
  public static TypeName get_net_nosica_lang_char_array() { return net_nosica_lang_char_array; }

  public static TypeName get_net_nosica_lang_string() { return net_nosica_lang_string; }
  public static TypeName get_net_nosica_lang_string_array() { return net_nosica_lang_string_array; }

  public static TypeName get_net_nosica_lang_Array() { return net_nosica_lang_Array; }

  public static TypeName get_net_nosica_lang_bool() { return net_nosica_lang_bool; }

  public static TypeName get_net_nosica_lang_None() { return net_nosica_lang_None; }

  public static TypeName get_net_nosica_lang_Exception() { return net_nosica_lang_Exception; }
  public static TypeName get_net_nosica_lang_Throwable() { return net_nosica_lang_Throwable; }
  public static TypeName get_net_nosica_lang_RuntimeException() { return net_nosica_lang_RuntimeException; }

  static
  {
    TypeNameComponent net = new TypeNameComponentImpl("net", null);
    TypeNameComponent nosica = new TypeNameComponentImpl("nosica", null);
    TypeNameComponent lang = new TypeNameComponentImpl("lang", null);

    ArrayList net_nosica_lang_components = new ArrayList();
    net_nosica_lang_components.add(net);
    net_nosica_lang_components.add(nosica);
    net_nosica_lang_components.add(lang);
    net_nosica_lang = new TypeNameImpl(net_nosica_lang_components);

    ArrayList net_nosica_lang_Object_components = new ArrayList();
    net_nosica_lang_Object_components.add(net);
    net_nosica_lang_Object_components.add(nosica);
    net_nosica_lang_Object_components.add(lang);
    net_nosica_lang_Object_components.add(new TypeNameComponentImpl("Object", null));
    net_nosica_lang_Object = new TypeNameImpl(net_nosica_lang_Object_components);

    ArrayList net_nosica_lang_General_components = new ArrayList();
    net_nosica_lang_General_components.add(net);
    net_nosica_lang_General_components.add(nosica);
    net_nosica_lang_General_components.add(lang);
    net_nosica_lang_General_components.add(new TypeNameComponentImpl("General", null));
    net_nosica_lang_General = new TypeNameImpl(net_nosica_lang_General_components);

    ArrayList net_nosica_lang_int8_components = new ArrayList();
    net_nosica_lang_int8_components.add(net);
    net_nosica_lang_int8_components.add(nosica);
    net_nosica_lang_int8_components.add(lang);
    net_nosica_lang_int8_components.add(new TypeNameComponentImpl("int8", null));
    net_nosica_lang_int8 = new TypeNameImpl(net_nosica_lang_int8_components);

    ArrayList net_nosica_lang_int16_components = new ArrayList();
    net_nosica_lang_int16_components.add(net);
    net_nosica_lang_int16_components.add(nosica);
    net_nosica_lang_int16_components.add(lang);
    net_nosica_lang_int16_components.add(new TypeNameComponentImpl("int16", null));
    net_nosica_lang_int16 = new TypeNameImpl(net_nosica_lang_int16_components);

    ArrayList int_components = new ArrayList();
    int_components.add(new TypeNameComponentImpl("int", null));
    int_ = new TypeNameImpl(int_components);

    ArrayList net_nosica_lang_int32_components = new ArrayList();
    net_nosica_lang_int32_components.add(net);
    net_nosica_lang_int32_components.add(nosica);
    net_nosica_lang_int32_components.add(lang);
    net_nosica_lang_int32_components.add(new TypeNameComponentImpl("int32", null));
    net_nosica_lang_int32 = new TypeNameImpl(net_nosica_lang_int32_components);

    ArrayList net_nosica_lang_int64_components = new ArrayList();
    net_nosica_lang_int64_components.add(net);
    net_nosica_lang_int64_components.add(nosica);
    net_nosica_lang_int64_components.add(lang);
    net_nosica_lang_int64_components.add(new TypeNameComponentImpl("int64", null));
    net_nosica_lang_int64 = new TypeNameImpl(net_nosica_lang_int64_components);

    ArrayList net_nosica_lang_word8_components = new ArrayList();
    net_nosica_lang_word8_components.add(net);
    net_nosica_lang_word8_components.add(nosica);
    net_nosica_lang_word8_components.add(lang);
    net_nosica_lang_word8_components.add(new TypeNameComponentImpl("word8", null));
    net_nosica_lang_word8 = new TypeNameImpl(net_nosica_lang_word8_components);

    ArrayList net_nosica_lang_word16_components = new ArrayList();
    net_nosica_lang_word16_components.add(net);
    net_nosica_lang_word16_components.add(nosica);
    net_nosica_lang_word16_components.add(lang);
    net_nosica_lang_word16_components.add(new TypeNameComponentImpl("word16", null));
    net_nosica_lang_word16 = new TypeNameImpl(net_nosica_lang_word16_components);

    ArrayList word_components = new ArrayList();
    word_components.add(new TypeNameComponentImpl("word", null));
    word = new TypeNameImpl(word_components);

    ArrayList net_nosica_lang_word32_components = new ArrayList();
    net_nosica_lang_word32_components.add(net);
    net_nosica_lang_word32_components.add(nosica);
    net_nosica_lang_word32_components.add(lang);
    net_nosica_lang_word32_components.add(new TypeNameComponentImpl("word32", null));
    net_nosica_lang_word32 = new TypeNameImpl(net_nosica_lang_word32_components);

    ArrayList net_nosica_lang_word64_components = new ArrayList();
    net_nosica_lang_word64_components.add(net);
    net_nosica_lang_word64_components.add(nosica);
    net_nosica_lang_word64_components.add(lang);
    net_nosica_lang_word64_components.add(new TypeNameComponentImpl("word64", null));
    net_nosica_lang_word64 = new TypeNameImpl(net_nosica_lang_word64_components);

    ArrayList float_components = new ArrayList();
    float_components.add(new TypeNameComponentImpl("float", null));
    float_ = new TypeNameImpl(float_components);

    ArrayList net_nosica_lang_float32_components = new ArrayList();
    net_nosica_lang_float32_components.add(net);
    net_nosica_lang_float32_components.add(nosica);
    net_nosica_lang_float32_components.add(lang);
    net_nosica_lang_float32_components.add(new TypeNameComponentImpl("float32", null));
    net_nosica_lang_float32 = new TypeNameImpl(net_nosica_lang_float32_components);

    ArrayList net_nosica_lang_float64_components = new ArrayList();
    net_nosica_lang_float64_components.add(net);
    net_nosica_lang_float64_components.add(nosica);
    net_nosica_lang_float64_components.add(lang);
    net_nosica_lang_float64_components.add(new TypeNameComponentImpl("float64", null));
    net_nosica_lang_float64 = new TypeNameImpl(net_nosica_lang_float64_components);

    ArrayList net_nosica_lang_char_components = new ArrayList();
    net_nosica_lang_char_components.add(net);
    net_nosica_lang_char_components.add(nosica);
    net_nosica_lang_char_components.add(lang);
    net_nosica_lang_char_components.add(new TypeNameComponentImpl("char", null));
    net_nosica_lang_char = new TypeNameImpl(net_nosica_lang_char_components);

    net_nosica_lang_char_array = new TypeNameImpl(1, net_nosica_lang_char);

    ArrayList net_nosica_lang_string_components = new ArrayList();
    net_nosica_lang_string_components.add(net);
    net_nosica_lang_string_components.add(nosica);
    net_nosica_lang_string_components.add(lang);
    net_nosica_lang_string_components.add(new TypeNameComponentImpl("string", null));
    net_nosica_lang_string = new TypeNameImpl(net_nosica_lang_string_components);

    net_nosica_lang_string_array = new TypeNameImpl(1, net_nosica_lang_string);

    ArrayList net_nosica_lang_Array_components = new ArrayList();
    net_nosica_lang_Array_components.add(net);
    net_nosica_lang_Array_components.add(nosica);
    net_nosica_lang_Array_components.add(lang);
    net_nosica_lang_Array_components.add(new TypeNameComponentImpl("Array", null));
    net_nosica_lang_Array = new TypeNameImpl(net_nosica_lang_Array_components);

    ArrayList net_nosica_lang_bool_components = new ArrayList();
    net_nosica_lang_bool_components.add(net);
    net_nosica_lang_bool_components.add(nosica);
    net_nosica_lang_bool_components.add(lang);
    net_nosica_lang_bool_components.add(new TypeNameComponentImpl("bool", null));
    net_nosica_lang_bool = new TypeNameImpl(net_nosica_lang_bool_components);

    ArrayList net_nosica_lang_None_components = new ArrayList();
    net_nosica_lang_None_components.add(net);
    net_nosica_lang_None_components.add(nosica);
    net_nosica_lang_None_components.add(lang);
    net_nosica_lang_None_components.add(new TypeNameComponentImpl("None", null));
    net_nosica_lang_None = new TypeNameImpl(net_nosica_lang_None_components);

    ArrayList net_nosica_lang_Exception_components = new ArrayList();
    net_nosica_lang_Exception_components.add(net);
    net_nosica_lang_Exception_components.add(nosica);
    net_nosica_lang_Exception_components.add(lang);
    net_nosica_lang_Exception_components.add(new TypeNameComponentImpl("Exception", null));
    net_nosica_lang_Exception = new TypeNameImpl(net_nosica_lang_Exception_components);

    ArrayList net_nosica_lang_Throwable_components = new ArrayList();
    net_nosica_lang_Throwable_components.add(net);
    net_nosica_lang_Throwable_components.add(nosica);
    net_nosica_lang_Throwable_components.add(lang);
    net_nosica_lang_Throwable_components.add(new TypeNameComponentImpl("Throwable", null));
    net_nosica_lang_Throwable = new TypeNameImpl(net_nosica_lang_Throwable_components);

    ArrayList net_nosica_lang_RuntimeException_components = new ArrayList();
    net_nosica_lang_RuntimeException_components.add(net);
    net_nosica_lang_RuntimeException_components.add(nosica);
    net_nosica_lang_RuntimeException_components.add(lang);
    net_nosica_lang_RuntimeException_components.add(new TypeNameComponentImpl("RuntimeException", null));
    net_nosica_lang_RuntimeException = new TypeNameImpl(net_nosica_lang_RuntimeException_components);
  }

  static public boolean isPositiveInteger(TypeName typeName)
  {
    return typeName.equals(net_nosica_lang_word8) ||
           typeName.equals(net_nosica_lang_word16) ||
           typeName.equals(net_nosica_lang_word32) ||
           typeName.equals(net_nosica_lang_word64);
  }
}