/*
  $Id: NullMessageServiceImpl.java,v 1.6 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.application;

import net.nosica.compiler.application.Filter;
import net.nosica.framework.Localizable;

/**
 * \brief a null implementation of the MessageService
 *
 * This is the default implementation used by the parser
 */
public class NullMessageServiceImpl implements MessageService
{
  static private NullMessageServiceImpl instance = new NullMessageServiceImpl();
  static public NullMessageServiceImpl instance() { return instance; }

  public void report(MessageLevel level, String msgId, String[] params, Localizable localizable)
  {
  }

  public void report(MessageLevel level, String msgId, String param, Localizable localizable)
  {
  }

  public void report(MessageLevel level, String msgId, Localizable localizable)
  {
  }

  public void report(MessageLevel level, String msgId)
  {
  }

  public int getNbError()
  {
    return 0;
  }

  public int getNbWarning()
  {
    return 0;
  }

  public void attachFilter(Filter filter)
  {
  }
}