/*
  $Id: PropertyKindEnum.java,v 1.4 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.application;

/**
 * \brief kind of property
 * This is used to gives property a notion of type
 */

public class PropertyKindEnum
{
  static public final PropertyKindEnum StringValue   = new PropertyKindEnum(1);
  static public final PropertyKindEnum IntValue      = new PropertyKindEnum(2);
  static public final PropertyKindEnum PathValue     = new PropertyKindEnum(3);
  static public final PropertyKindEnum PathListValue = new PropertyKindEnum(4);
  static public final PropertyKindEnum BooleanValue  = new PropertyKindEnum(5);

  private int value_;
  private PropertyKindEnum(int value) { value_ = value; }
  public String toString()
  {
    switch (value_)
    {
    case 1 : return "String";
    case 2 : return "Int";
    case 3 : return "Path";
    case 4 : return "PathList";
    case 5 : return "Boolean";
    }

    throw new Error("Internal error : Cound not recognize property kind");
  }
}
