/*
  $Id: ExceptionEnvironmentDisplayer.java,v 1.6 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package net.nosica.compiler.application;

import net.nosica.parser.node.util.var.TypeName;
import net.nosica.compiler.intermediate.Function;

import net.nosica.util.IndentedPrintWriter;

import java.util.Iterator;
import java.util.Set;
import java.util.Map.Entry;

/**
  \brief display all found RuntimeException and their methods
 */
public class ExceptionEnvironmentDisplayer
{
  private IndentedPrintWriter writer;

  public ExceptionEnvironmentDisplayer(IndentedPrintWriter writer) { this.writer = writer; }

  public void display()
  {
    Iterator it = Environment.instance().getEE().iterateExceptions();
    while (it.hasNext())
    {
      Entry entry = (Entry)it.next();
      Function f = (Function)entry.getKey();
      Set runtimeExceptions = (Set)entry.getValue();

      writer.println("Method " + f.getMethod().toString() + ":");
      writer.addIndent();

      Iterator j = runtimeExceptions.iterator();
      while (j.hasNext())
      {
        TypeName typeName = (TypeName)j.next();
        writer.println(typeName.toString());
      }

      writer.decIndent();
    }
  }

  public void displayType(String type)
  {
    Iterator it = Environment.instance().getEE().iterateExceptions();
    while (it.hasNext())
    {
      Entry entry = (Entry)it.next();
      Function f = (Function)entry.getKey();

      if (!f.getMethod().getType().toString().equals(type))
      {
        continue;
      }

      Set runtimeExceptions = (Set)entry.getValue();

      writer.println("Method " + f.getMethod().toString() + ":");
      writer.addIndent();

      Iterator j = runtimeExceptions.iterator();
      while (j.hasNext())
      {
        TypeName typeName = (TypeName)j.next();
        writer.println(typeName.toString());
      }

      writer.decIndent();
    }

    writer.println();
  }
}
