/*
  $Id: ConditionalJump.java,v 1.6 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.compiler.intermediate;

import net.nosica.compiler.typechecker.Label;

/**
 * \brief representation of a conditional jump
 */
public interface ConditionalJump extends Statement
{
  /**
   * \brief return the condition to use for deciding wether to branch on true or false label
   *
   * \return IR expression
   */
  Expression getCondition();

  /**
   * \brief set the new condition
   *
   * \param condition the condition to set
   */
  void setCondition(Expression condition);

  /**
   * \brief return the true label to branch to if condition is true
   *
   * \return true label
   */
  Label getTrueLabel();

  /**
   * \brief return the false label to branch to if condition is false
   *
   * \return false label
   */
  Label getFalseLabel();
}