/*
  $Id: Expression.java,v 1.9 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.compiler.intermediate;

import net.nosica.framework.Localizable;
import net.nosica.parser.node.util.var.TypeName;

/**
 * \brief base interface for all expression that compute a value possibly with side effect
 */
public interface Expression extends IRNode, Localizable
{
  /**
   * \brief indicates if this expression is a member access to super
   *
   * \return true if expression is a MemberAccess to super
   */
  boolean isSuper();

  /**
   * \brief indicates if this expression is variable this
   *
   * \return true if expression is variable this
   */
  boolean isThis();

  /**
   * \brief indicates if this expression is a member access to a static field
   *
   * \return true if expression is a MemberAccess to a static field
   */
   boolean isStatic();

   /**
    * \brief is this expression an argument ?
    *
    * \return true if expression is in fact an argument
    */
   boolean isArgument();

   /**
    * \brief return the typeName of this expression
    *
    * \return typeName of this expression
    */
   TypeName getTypeName();
}