/*
  $Id: FunctionImpl.java,v 1.12 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.compiler.intermediate;

import net.nosica.compiler.typechecker.Method;
import net.nosica.framework.VisitorException;

import java.util.ArrayList;
import java.util.Iterator;

public class FunctionImpl implements Function
{
  private Method method;
  private Statement statement;
  private ArrayList args = new ArrayList();  // ArrayList<Variable>
  private Variable thisVariable;

  //
  // ArrayList<intermediate.Variable>
  //
  public FunctionImpl(
    Method method,
    ArrayList methodArgs,
    Statement statement,
    Variable thisVariable
    ) throws VisitorException
  {
    this.method = method;
    this.statement = statement;
    this.args = methodArgs;

    this.thisVariable = thisVariable;
  }

  public Method getMethod() { return method; }
  public Statement getStatement() { return statement; }
  public void setStatement(Statement statement) { this.statement = statement; }
  public Iterator iterateArgs() { return args.iterator(); }
  public ArrayList getArgs() { return args; }

  public Variable    getThisInfo() { return thisVariable; }
}
