/*
  $Id: IRVisitor.java,v 1.10 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.compiler.intermediate;

import net.nosica.framework.VisitorException;

/**
 * \brief a visitor interface to visit all IR statements and expression
 */
public interface IRVisitor
{
  void visit(Call call) throws VisitorException;
  void visit(MemberAccess memberAccess) throws VisitorException;
  void visit(Literal literal) throws VisitorException;
  void visit(Sequence sequence) throws VisitorException;
  void visit(StatementExpression statementExpression) throws VisitorException;
  void visit(Variable variable) throws VisitorException;
  void visit(Move move) throws VisitorException;
  void visit(ExtendedSequence exSeq) throws VisitorException;
  void visit(Jump jump) throws VisitorException;
  void visit(LabelName labelName) throws VisitorException;
  void visit(ConditionalJump conditionalJump) throws VisitorException;
  void visit(Cast castExp) throws VisitorException;
  void visit(InstanceOf instanceOfExp) throws VisitorException;
  void visit(RawAllocation rawAllocation) throws VisitorException;
  void visit(Init init) throws VisitorException;
  void visit(StatementList statementList) throws VisitorException;
  void visit(ArraySet arraySet) throws VisitorException;
  void visit(ArrayGet arrayGet) throws VisitorException;
  void visit(ConstraintError constraintError) throws VisitorException;
  void visit(TryRegister tryRegister) throws VisitorException;
  void visit(TryUnregister tryUnregister) throws VisitorException;
  void visit(Throw throwStatement) throws VisitorException;
  void visit(VariableScopeLeave varScopeLeave) throws VisitorException;
  void visit(Return returnStatement) throws VisitorException;
}