/*
  $Id: Init.java,v 1.6 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.compiler.intermediate;

/**
 * \brief represents an initialization
 *
 * An initialization is like a move, except that we know it's a "move-on-creation"
 * That is, it permits to distinguish
 *
 * Toto toto = null;
 *
 * from
 *
 * Toto toto;
 * toto = null;
 *
 * First case will translate to : INIT(Variable(toto), Literal(null))
 * Second case will translate to : MOVE(Variable(toto), literal(null))
 *
 * In first case, there is no doubt : first run time type of toto will be null
 * In second case, there could have code between declaration of toto and affectation : run time type
 * could be different !
 */
public interface Init extends Move
{
}