/*
  $Id: MemberAccessImpl.java,v 1.10 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.compiler.intermediate;

import net.nosica.framework.VisitorException;
import net.nosica.parser.node.util.var.TypeName;

public class MemberAccessImpl implements MemberAccess
{
  private Expression subscript;
  private Field field;
  private boolean isConst;
  private String localization = null;

  public MemberAccessImpl(Expression subscript, Field field)
  {
    this.subscript = subscript;
    this.field = field;
  }

  public boolean isSuper() { return field.getName().equals("super"); }
  public boolean isThis() { return false; }
  public boolean isStatic() { return field.isStatic(); }
  public boolean hasSubscript() { return subscript != null; }
  public Expression getSubscript() { return subscript; }
  public void setSubscript(Expression subscript) { this.subscript = subscript; }
  public String getName() { return field.getName(); }
  public void setName(String name) { throw new UnsupportedOperationException(); }
  public Field getField() { return field; }
  public boolean isConst() { return isConst; }

  public TypeName getTypeName() { return field.getTypeName(); }

  public boolean isArgument() { return false; }

  public String localization()
  {
    return localization;
  }

  public void setLocalization(String localization)
  {
    this.localization = localization;
  }

  public void accept(IRVisitor visitor) throws VisitorException
  {
    visitor.visit(this);
  }
}