/*
  $Id: RecordImpl.java,v 1.7 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.compiler.intermediate;

import net.nosica.parser.node.util.var.TypeName;
import net.nosica.symbol.SymbolException;

import java.util.ArrayList;
import java.util.Iterator;

public class RecordImpl implements Record
{
  private TypeName name;
  private TypeName extendsTypeName;
  private TypeName enclosingTypeName;
  private ArrayList fields;            // ArrayList<Field>
  private int typeCode;

  public RecordImpl(TypeName name, TypeName extendsTypeName, TypeName enclosingTypeName, ArrayList fields, int typeCode)
  {
    this.name = name;
    this.extendsTypeName = extendsTypeName;
    this.enclosingTypeName = enclosingTypeName;
    this.fields = fields;
    this.typeCode = typeCode;
  }

  public TypeName getName() { return name; }
  public boolean hasExtends() { return extendsTypeName != null; }
  public TypeName getExtends() { return extendsTypeName; }
  public boolean hasEnclosing() { return enclosingTypeName != null; }
  public TypeName getEnclosing() { return enclosingTypeName; }
  public Iterator iterateFields() { return fields.iterator(); }
  public Field getField(String name) throws SymbolException
  {
    Iterator it = fields.iterator();
    while (it.hasNext())
    {
      Field field = (Field)it.next();
      if (field.getName().equals(name))
        return field;
    }

    throw new SymbolException("Field named [" + name + "] does not exists");
  }
  public int getTypeCode() { return typeCode; }
}