/*
  $Id: FieldContextImpl.java,v 1.7 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.compiler.typechecker;

import net.nosica.parser.node.util.var.TypeName;
import net.nosica.util.Pair;

import java.util.Stack;
import java.util.Iterator;

public class FieldContextImpl implements FieldContext
{
  private Field field;
  private boolean isConst;
  private Stack subscript = new Stack();   // Stack<Pair<Boolean, TypeName>>

  /**
   * \brief creates a new Field Context
   *
   * \param field the field to use to create this Field Context
   */
  public FieldContextImpl(
          Field field
         )
  {
    this.field = field;
    this.isConst = field.isConst();
  }

  public Field getField() { return field; }

  public void insertEnclosing(TypeName enclosingType)
  {
    subscript.push(new Pair(new Boolean(true), enclosingType));
  }
  public void insertSuper(TypeName superType)
  {
    subscript.push(new Pair(new Boolean(false), superType));
  }
  public Iterator iterateSubscript() { return subscript.iterator(); }

  public void setConst(boolean isConst) { this.isConst = isConst; }

  // Implements Variable
  public String getName() { return field.getName(); }
  public TypeName getTypeName() { return field.getTypeName(); }
  public boolean isConst() { return isConst; }
  public boolean isInitialized() { return field.isInitialized(); }
  public boolean isArgument() { return false; }
}
