/*
  $Id: TypeCheckerResultTypeImpl.java,v 1.14 2004/03/04 22:16:16 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.compiler.typechecker;

import net.nosica.parser.node.util.var.TypeName;
import net.nosica.parser.node.Node;
import net.nosica.symbol.MethodKindEnum;

import java.util.ArrayList;

public class TypeCheckerResultTypeImpl implements TypeCheckerResultType
{
  private TypeName typeName;
  private boolean isConst;

  public TypeCheckerResultTypeImpl(TypeName typeName, boolean isConst)
  {
    this.typeName = typeName;
    this.isConst = isConst;
  }

  public TypeName getTypeName() { return typeName; }
  public boolean isConst() { return isConst; }
  public boolean isSub() { return false; }
  public boolean isStatic() { return false; }
  public boolean isPropertySet() { return false; }
  public ArrayList getTranslatedPropertySetArguments() { return null; }
  public Method createAssignOperator(TypeCheckerResultType right, Node node)
  {
    ArrayList arguments = new ArrayList();
    arguments.add(new ArgumentImpl(right.isConst(), right.getTypeName(), ""));

    return new MethodImpl(false, "=", MethodKindEnum.infix, arguments, false, null);
  }
  public ArrayList resolvePropertySet(
    TypeCheckerResultType right,
    TypeName accessor,
    ArrayList matchingNames,
    Node node)
  {
    return null;
  }
  public String toString()
  {
    return (isConst ? "const " : "") + typeName.toString();
  }
}