/*
  $Id: CommentHelper.java,v 1.6 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.doc.application;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.StringTokenizer;

public class CommentHelper
{
  /**
   * \brief filter relevant commens
   *
   * Only one line comment starting with //!, //* are kept
   * Only one multi comment starting with /** and /*! are kept
   *
   * \param comments ArrayList<String>
   */
  static public ArrayList filterComments(ArrayList comments)
  {
    ArrayList result = new ArrayList();

    Iterator it = comments.iterator();
    while (it.hasNext())
    {
      String comment = (String)it.next();

      // one line //! style comment
      int index = comment.indexOf("//!");
      if (index == -1)
      {
        index = comment.indexOf("//*");
      }
      if (index == 0)
      {
        comment = comment.substring(index + 3);
        result.add(comment);
        continue;
      }

      index = comment.indexOf("/**");
      if (index == -1)
      {
        index = comment.indexOf("/*!");
      }
      if (index == -1)
      {
        continue;
      }

      // multiple line /** style comment

      // first remove /** comment
      comment = comment.substring(index + 3);
      // remove end of comment */
      index = comment.lastIndexOf("*/");
      if (index != -1)
      {
        comment = comment.substring(0, index);
      }
      /* for presentation purpose like this one
       * multiple line comment starting with a '*' are authorized.
       * let's remove them
       */
      StringTokenizer tokenizer = new StringTokenizer(comment, "\n");
      while (tokenizer.hasMoreTokens())
      {
        String token = tokenizer.nextToken();
        token = token.trim(); // remove white spaces
        if (token.indexOf("*") == 0)
        {
          token = token.substring(1);
          token = token.trim();
        }

        if (token.length() == 0)
          continue;

        result.add(token);
      }
    }

    return result;
  }
}