/*
  $Id: ReverseEnvironmentImpl.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.doc.application;

import net.nosica.parser.node.util.var.TypeName;

import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;
import java.util.Iterator;

public class ReverseEnvironmentImpl implements ReverseEnvironment
{
  static private ReverseEnvironmentImpl instance = new ReverseEnvironmentImpl();
  private ReverseEnvironmentImpl() {}
  static public ReverseEnvironmentImpl instance() { return instance; }

  // reverse inheritance mapping
  private Map reverseInheritance = new HashMap(); // Map<TypeName, Set<TypeName> >

  public void addReverse(TypeName inherited, TypeName subType)
  {
    Set subTypes = null;
    if (reverseInheritance.containsKey(inherited))
    {
      subTypes = (Set)reverseInheritance.get(inherited);
    }
    else
    {
      subTypes = new HashSet();
      reverseInheritance.put(inherited, subTypes);
    }

    subTypes.add(subType);
  }

  public Iterator iterateSubTypes(TypeName typeName)
  {
    Set subTypes = (Set)reverseInheritance.get(typeName);
    if (subTypes == null)
    {
      return java.util.Collections.EMPTY_SET.iterator();
    }
    else
    {
      return subTypes.iterator();
    }
  }
}