/*
  $Id: MethodHelper.java,v 1.1 2004/04/01 21:27:55 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.ni;

import net.nosica.symbol.GenericMethod;

import net.nosica.compiler.typechecker.ArgumentImpl;
import net.nosica.compiler.typechecker.Method;
import net.nosica.compiler.typechecker.MethodImpl;
import net.nosica.compiler.typechecker.ResultType;
import net.nosica.compiler.typechecker.ResultTypeImpl;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.HashMap;
import java.util.Map;

public class MethodHelper
{
  private static Map cache = new HashMap(); // Map<GenericMethod, Method>

  public static boolean isNative(GenericMethod method)
  {
    net.nosica.parser.node.typedeclaration.Method m =
      (net.nosica.parser.node.typedeclaration.Method)method.getNode();

    return (m == null || !m.hasBlock());
  }

  public static Method instantiateMethod(GenericMethod method)
  {
    Method m = (Method)cache.get(method);
    if (m != null)
    {
      return m;
    }

    m = new MethodImpl(
      method,
      instantiateResultType(method.getResultType()),
      instantiateArguments(method.getArguments()),
      java.util.Collections.EMPTY_SET,
      method.getEnclosing(),
      null
    );

    cache.put(method, m);

    return m;
  }

  public static ResultType instantiateResultType(
    net.nosica.symbol.ResultType result
  )
  {
    if (result == null)
      return null;

    return new ResultTypeImpl(result.getTypeName(), result.isConst());
  }

  public static ArrayList instantiateArguments(ArrayList args)
  {
    ArrayList result = new ArrayList(); // ArrayList<Argument>

    Iterator it = args.iterator();
    while (it.hasNext())
    {
      net.nosica.symbol.Argument arg = (net.nosica.symbol.Argument)it.next();
      result.add(
        new ArgumentImpl(
          arg.isConst(),
          arg.getTypeName(),
          arg.getName()
        )
      );
    }

    return result;
  }
}