/*
  $Id: AbstractNodeVisitor.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node;

import  net.nosica.parser.node.filestructure.*;
import  net.nosica.parser.node.typedeclaration.*;
import  net.nosica.parser.node.typedeclaration.expression.*;
import  net.nosica.parser.node.typedeclaration.statement.*;
import  net.nosica.parser.node.util.generic.*;
import  net.nosica.parser.node.util.var.*;

/**
 * Default implementation of a node visitor<BR>
 * Do nothing<BR>
 * Make it easy to implement a new visitor, but can be cumbersome to debug if <BR>
 * one has forgotten to overload one of these methods
 */

public abstract class AbstractNodeVisitor implements NodeVisitor
{
  public void visit(CompilationUnit compilationUnit) {}
  public void visit(PackageDeclaration packageDecl) {}
  public void visit(ImportDeclaration importDecl) {}
  public void visit(CastOperatorDeclaration castOpDecl) {}
  public void visit(ClassBody classBody) {}
  public void visit(ClassBodyDeclaration classBodyDecl) {}
  public void visit(ClassDeclaration classDecl) {}
  public void visit(ConstructorDeclaration constructorDecl) {}
  public void visit(DestructorDeclaration destructorDecl) {}
  public void visit(ExplicitConstructorInvocation constructorInvocation) {}
  public void visit(FieldDeclaration fieldDecl) {}
  public void visit(Initializer init) {}
  public void visit(Deinitializer deinit) {}
  public void visit(InterfaceDeclaration interfaceDecl) {}
  public void visit(InterfaceMemberDeclaration interfaceMemberDecl) {}
  public void visit(MethodDeclaration methodDecl) {}
  public void visit(MethodDeclarator methodDecl) {}
  public void visit(NestedClassDeclaration nestedClassDecl) {}
  public void visit(NestedInterfaceDeclaration nestedInterfaceDecl) {}
  public void visit(OperatorDeclaration opDecl) {}
  public void visit(PropertyDeclaration opDecl) {}
  public void visit(TypeDeclaration typeDecl) {}
  public void visit(AliasDeclaration aliasDecl) {}
  public void visit(AdditiveExpression addExp) {}
  public void visit(AllocationExpression allocExp) {}
  public void visit(AssignExpression assignExp) {}
  public void visit(CastExpression castExp) {}
  public void visit(ConditionalAndExpression condAndExp) {}
  public void visit(ConditionalExpression condExp) {}
  public void visit(ConditionalOrExpression condOrExp) {}
  public void visit(EqualityExpression eqExpression) {}
  public void visit(InstanceOfExpression instanceOfExp) {}
  public void visit(ImpliesExpression implyExp) {}
  public void visit(MultiplicativeExpression mulExp) {}
  public void visit(PrefixExpression preFixExp) {}
  public void visit(PowerExpression powerExp) {}
  public void visit(PrimaryExpression primaryExp) {}
  public void visit(PrimaryComponent primaryComponent) {}
  public void visit(RelationalExpression relationalExp) {}
  public void visit(UnaryExpression unaryExp) {}
  public void visit(UnaryExpressionNotPlusMinus unaryExp) {}
  public void visit(StreamExpression streamExp) {}
  public void visit(Block block) {}
  public void visit(BlockStatement blockStatement) {}
  public void visit(BreakStatement breakStatement) {}
  public void visit(CatchStatement catchStatement) {}
  public void visit(ContinueStatement continueStatement) {}
  public void visit(DoStatement doStatement) {}
  public void visit(EmptyStatement emptyStatement) {}
  public void visit(ForInit forInit) {}
  public void visit(ForStatement forStatement) {}
  public void visit(ForUpdate forUpdate) {}
  public void visit(IfStatement ifStatement) {}
  public void visit(LabeledStatement labeledStatement) {}
  public void visit(LocalVariableDeclaration localVar) {}
  public void visit(ReturnStatement returnStatement) {}
  public void visit(StatementExpressionTerminator statementExpression) {}
  public void visit(StatementExpression statementExpression) {}
  public void visit(StatementExpressionList statementExpressionList) {}
  public void visit(SwitchLabel switchLabel) {}
  public void visit(SwitchStatement switchStatement) {}
  public void visit(ThrowStatement throwStatement) {}
  public void visit(TryStatement tryStatement) {}
  public void visit(WhileStatement whileStatement) {}
  public void visit(GenericDeclaration genericDecl) {}
  public void visit(GenericParameter genericParm) {}
  public void visit(ArgumentList argList) {}
  public void visit(Arguments args) {}
  public void visit(ArrayDimsAndInits arrayDimsAndInits) {}
  public void visit(ArrayInitializer arrayInit) {}
  public void visit(FormalParameter formalParm) {}
  public void visit(FormalParameters formalParms) {}
  public void visit(TypeNameComponent typeNameComponent) {}
  public void visit(TypeName typeName) {}
  public void visit(TypeNameList typeNameList) {}
  public void visit(ResultType resultType) {}
  public void visit(VariableDeclarator varDecl) {}
  public void visit(VariableInitializer varInit) {}
}
