/*
  $Id: FieldDeclarationImpl.java,v 1.6 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.typedeclaration;

import  java.util.ArrayList;
import  java.util.Iterator;
import  net.nosica.framework.Visitor;
import  net.nosica.parser.node.NodeVisitor;
import  net.nosica.parser.node.util.var.TypeName;

public class FieldDeclarationImpl extends AbstractSymbol implements FieldDeclaration
{
  private boolean isPublic = false;
  private boolean isProtected = false;
  private boolean isPrivate = false;
  private boolean isStatic = false;
  private boolean isConst = false;
  private boolean isMutable = false;
  private boolean isTransient = false;
  private TypeName typeName;
  private ArrayList varDecls;

  public FieldDeclarationImpl(
    TypeName typeName,
    ArrayList varDecls,
    boolean isPublic,
    boolean isProtected,
    boolean isPrivate,
    boolean isStatic,
    boolean isConst,
    boolean isMutable,
    boolean isTransient
  )
  {
    this("", null, typeName, varDecls, isPublic, isProtected, isPrivate, isStatic, isConst, isMutable, isTransient);
  }

  public FieldDeclarationImpl(
    String localization,
    ArrayList comments,
    TypeName typeName,
    ArrayList varDecls,
    boolean isPublic,
    boolean isProtected,
    boolean isPrivate,
    boolean isStatic,
    boolean isConst,
    boolean isMutable,
    boolean isTransient
  )
  {
    super(localization, comments);

    this.typeName = typeName;
    this.varDecls = varDecls;
    this.isPublic = isPublic;
    this.isProtected = isProtected;
    this.isPrivate = isPrivate;
    this.isStatic = isStatic;
    this.isConst = isConst;
    this.isMutable = isMutable;
    this.isTransient = isTransient;
  }

  public TypeName getTypeName() {return typeName;}
  public Iterator iterateVariableDeclarator() {return varDecls.iterator();}
  public boolean isPublic() {return isPublic;}
  public boolean isProtected() {return isProtected;}
  public boolean isPrivate() {return isPrivate;}
  public boolean isStatic() {return isStatic;}
  public boolean isConst() {return isConst;}
  public boolean isMutable() {return isMutable;}
  public boolean isTransient() {return isTransient;}

  public void accept(Visitor visitor)
  {
    ((NodeVisitor)visitor).visit(this);
  }
}
