/*
  $Id: MethodDeclaratorImpl.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.typedeclaration;

import  net.nosica.framework.Visitor;
import  net.nosica.parser.node.AbstractNode;
import  net.nosica.parser.node.NodeVisitor;
import  net.nosica.parser.node.util.generic.GenericDeclaration;
import  net.nosica.parser.node.util.var.FormalParameters;

public class MethodDeclaratorImpl extends AbstractNode implements MethodDeclarator
{
  private String methodName;
  private GenericDeclaration genericDecl = null;
  private FormalParameters formalParameters = null;

  public MethodDeclaratorImpl(
                              String methodName,
                              GenericDeclaration genericDecl,
                              FormalParameters formalParameters
                             )
  {
    this("", methodName, genericDecl, formalParameters);
  }

  public MethodDeclaratorImpl(
                              String localization,
                              String methodName,
                              GenericDeclaration genericDecl,
                              FormalParameters formalParameters
                             )
  {
    super(localization);

    this.methodName = methodName;
    this.genericDecl = genericDecl;
    this.formalParameters = formalParameters;
  }

  public String getName() {return methodName;}
  public boolean hasGenericDeclaration() {return genericDecl != null;}
  public GenericDeclaration getGenericDeclaration() {return genericDecl;}
  public FormalParameters getFormalParameters() {return formalParameters;}

  public void accept(Visitor visitor)
  {
    ((NodeVisitor)visitor).visit(this);
  }
}
