/*
  $Id: AllocationExpressionImpl.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.typedeclaration.expression;

import  net.nosica.framework.Visitor;
import  net.nosica.parser.node.AbstractNode;
import  net.nosica.parser.node.NodeVisitor;
import  net.nosica.parser.node.util.var.TypeName;
import  net.nosica.parser.node.util.var.ArrayDimsAndInits;
import  net.nosica.parser.node.util.var.Arguments;
import  net.nosica.parser.node.typedeclaration.ClassBody;

public class AllocationExpressionImpl extends AbstractNode implements AllocationExpression
{
  private TypeName type;
  private ArrayDimsAndInits arrayDims = null;
  private Arguments arguments = null;
  private ClassBody classBody = null;

  public AllocationExpressionImpl(TypeName type, ArrayDimsAndInits arrayDims)
  {
    this("", type, arrayDims);
  }

  public AllocationExpressionImpl(TypeName type, Arguments arguments, ClassBody classBody)
  {
    this("", type, arguments, classBody);
  }

  public AllocationExpressionImpl(String localization, TypeName type, ArrayDimsAndInits arrayDims)
  {
    super(localization);

    this.type = type;
    this.arrayDims = arrayDims;
  }

  public AllocationExpressionImpl(String localization, TypeName type, Arguments arguments, ClassBody classBody)
  {
    super(localization);

    this.type = type;
    this.arguments = arguments;
    this.classBody = classBody;
  }

  public TypeName getType()
  {
    return type;
  }

  public boolean hasArrayDims()
  {
    return arrayDims != null;
  }

  public ArrayDimsAndInits getArrayDims()
  {
    return arrayDims;
  }

  public boolean hasArguments()
  {
    return arguments != null;
  }

  public Arguments getArguments()
  {
    return arguments;
  }

  public boolean hasClassBody()
  {
    return classBody != null;
  }

  public ClassBody getClassBody()
  {
    return classBody;
  }

  public void accept(Visitor visitor)
  {
    ((NodeVisitor)visitor).visit(this);
  }
}
