/*
  $Id: MultiplicativeExpressionImpl.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.typedeclaration.expression;

import  net.nosica.framework.Visitor;
import  net.nosica.parser.node.AbstractNode;
import  net.nosica.parser.node.NodeVisitor;
import  net.nosica.parser.node.util.operator.Operator;

public class MultiplicativeExpressionImpl extends AbstractNode implements MultiplicativeExpression
{
  private Expression left;
  private Expression right = null;
  private Operator op = null;

  public MultiplicativeExpressionImpl(Expression left, Expression right, Operator op)
  {
    this("", left, right, op);
  }

  public MultiplicativeExpressionImpl(String localization, Expression left, Expression right, Operator op)
  {
    super(localization);

    this.left = left;
    this.right = right;
    this.op = op;
  }

  public Operator getOperator()
  {
    return op;
  }

  public Expression getLeft()
  {
    return left;
  }

  public Expression getRight()
  {
    return right;
  }

  public void accept(Visitor visitor)
  {
    ((NodeVisitor)visitor).visit(this);
  }
}
