/*
  $Id: PrimarySuffixImpl.java,v 1.5 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.typedeclaration.expression;

import  net.nosica.framework.Visitor;
import  net.nosica.parser.node.AbstractNode;
import  net.nosica.parser.node.NodeVisitor;
import  net.nosica.parser.node.util.var.Arguments;
import  net.nosica.parser.node.util.var.TypeName;
import  net.nosica.parser.node.util.literal.Literal;

import java.util.ArrayList;
import java.util.Iterator;

public class PrimarySuffixImpl extends AbstractNode implements PrimaryComponent
{
  private boolean isThis = false;
  private ArrayList expressions = null;
  private Arguments arguments = null;
  private String member = null;
  private AllocationExpression allocationExp;

  public PrimarySuffixImpl(String localization)
  {
    super(localization);

    isThis = true;
  }

  public PrimarySuffixImpl(String localization, ArrayList exp)
  {
    super(localization);

    this.expressions = exp;
  }

  public PrimarySuffixImpl(String localization, Arguments arguments)
  {
    super(localization);

    this.arguments = arguments;
  }

  public PrimarySuffixImpl(String localization, AllocationExpression allocationExp)
  {
    super(localization);

    this.allocationExp = allocationExp;
  }

  public PrimarySuffixImpl(String localization, String member)
  {
    super(localization);

    this.member = member;
  }

  public boolean isLiteral() { return false; }
  public boolean isThis() { return isThis; }
  public boolean isSuper() { return false; }
  public boolean isExpression() { return false; }
  public boolean isAllocation() { return allocationExp != null; }
  public boolean isTypeName() { return false; }
  public boolean isArrayAccess() { return expressions != null; }
  public boolean isMember() { return member != null; }
  public boolean isArguments() { return arguments != null; }

  public Literal getLiteral() { throw new UnsupportedOperationException(); }
  public Expression getExpression() { throw new UnsupportedOperationException(); }
  public AllocationExpression getAllocation() { return allocationExp; }
  public TypeName getTypeName() { throw new UnsupportedOperationException(); }
  public String getMember() { return member; }
  public Iterator iterateDimensions() { return expressions.iterator(); }
  public Arguments getArguments() { return arguments; }

  public void accept(Visitor visitor)
  {
    ((NodeVisitor)visitor).visit(this);
  }
}
