/*
  $Id: DoStatementImpl.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.typedeclaration.statement;

import  net.nosica.framework.Visitor;
import  net.nosica.parser.node.AbstractNode;
import  net.nosica.parser.node.NodeVisitor;
import  net.nosica.parser.node.typedeclaration.expression.Expression;

public class DoStatementImpl extends AbstractNode implements DoStatement
{
  private Expression condition;
  private Statement statement;
  private Statement elseStatement;

  public DoStatementImpl(Statement statement, Expression condition, Statement elseStatement)
  {
    this("", statement, condition, elseStatement);
  }

  public DoStatementImpl(String localization, Statement statement, Expression condition, Statement elseStatement)
  {
    super(localization);

    this.statement = statement;
    this.condition = condition;
    this.elseStatement = elseStatement;
  }

  public Expression getCondition()
  {
    return condition;
  }

  public Statement getStatement()
  {
    return statement;
  }

  public boolean hasElseStatement()
  {
    return elseStatement != null;
  }

  public Statement getElseStatement()
  {
    return elseStatement;
  }

  public void accept(Visitor visitor)
  {
    ((NodeVisitor)visitor).visit(this);
  }
}
