/*
  $Id: ForInitImpl.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.typedeclaration.statement;

import  net.nosica.framework.Visitor;
import  net.nosica.parser.node.AbstractNode;
import  net.nosica.parser.node.NodeVisitor;

public class ForInitImpl extends AbstractNode implements ForInit
{
  private LocalVariableDeclaration localVariable = null;
  private StatementExpressionList statements = null;

  public ForInitImpl(LocalVariableDeclaration localVariable)
  {
    this("", localVariable);
  }

  public ForInitImpl(StatementExpressionList statements)
  {
    this("", statements);
  }

  public ForInitImpl(String localization, LocalVariableDeclaration localVariable)
  {
    super(localization);

    this.localVariable = localVariable;
  }

  public ForInitImpl(String localization, StatementExpressionList statements)
  {
    super(localization);

    this.statements = statements;
  }

  public boolean isLocalVariable()
  {
    return localVariable != null;
  }

  public LocalVariableDeclaration getLocalVariable()
  {
    return localVariable;
  }

  public boolean isStatements()
  {
    return statements != null;
  }

  public StatementExpressionList getStatements()
  {
    return statements;
  }

  public void accept(Visitor visitor)
  {
    ((NodeVisitor)visitor).visit(this);
  }
}
