/*
  $Id: StatementExpressionImpl.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.typedeclaration.statement;

import  net.nosica.framework.Visitor;
import  net.nosica.parser.node.AbstractNode;
import  net.nosica.parser.node.NodeVisitor;
import  net.nosica.parser.node.typedeclaration.expression.Expression;
import  net.nosica.parser.node.typedeclaration.expression.AssignExpression;
import  net.nosica.parser.node.typedeclaration.expression.PrimaryExpression;
import  net.nosica.parser.node.typedeclaration.expression.StreamExpression;

public class StatementExpressionImpl extends AbstractNode implements StatementExpression
{
  private Expression prefix;
  private AssignExpression assignment;
  private PrimaryExpression primary;
  private StreamExpression stream;

  public StatementExpressionImpl(Expression prefix)
  {
    this("", prefix);
  }

  public StatementExpressionImpl(AssignExpression assignment)
  {
    this("", assignment);
  }

  public StatementExpressionImpl(PrimaryExpression primary)
  {
    this("", primary);
  }

  public StatementExpressionImpl(StreamExpression stream)
  {
    this("", stream);
  }

  public StatementExpressionImpl(String localization, Expression prefix)
  {
    super(localization);

    this.prefix = prefix;
  }

  public StatementExpressionImpl(String localization, AssignExpression assignment)
  {
    super(localization);

    this.assignment = assignment;
  }

  public StatementExpressionImpl(String localization, PrimaryExpression primary)
  {
    super(localization);

    this.primary = primary;
  }

  public StatementExpressionImpl(String localization, StreamExpression stream)
  {
    super(localization);

    this.stream = stream;
  }

  public boolean isPrefix()
  {
    return prefix != null;
  }

  public Expression getPrefix()
  {
    return prefix;
  }

  public boolean isPrimaryAssignment()
  {
    return assignment != null;
  }

  public AssignExpression getPrimaryAssignment()
  {
    return assignment;
  }

  public boolean isPrimary()
  {
    return primary != null;
  }

  public PrimaryExpression getPrimaryExpression()
  {
    return primary;
  }

  public boolean isStream()
  {
    return stream != null;
  }

  public StreamExpression getStream()
  {
    return stream;
  }

  public void accept(Visitor visitor)
  {
    ((NodeVisitor)visitor).visit(this);
  }
}
