/*
  $Id: GenericParameterImpl.java,v 1.7 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.util.generic;

import  net.nosica.framework.Visitor;
import  net.nosica.parser.node.AbstractNode;
import  net.nosica.parser.node.NodeVisitor;
import  net.nosica.parser.node.util.var.TypeName;

public class GenericParameterImpl extends AbstractNode implements GenericParameter
{
  private TypeName name;
  private TypeName implement;
  private TypeName defaultType;

  public GenericParameterImpl(TypeName name, TypeName implement, TypeName defaultType)
  {
    this("", name, implement, defaultType);
  }

  public GenericParameterImpl(String localization, TypeName name, TypeName implement, TypeName defaultType)
  {
    super(localization);

    this.name = name;
    this.defaultType = defaultType;
    this.implement = implement;
  }

  public TypeName getName() {return name;}
  public boolean hasImplements() { return implement != null; }
  public TypeName getImplements() {return implement;}
  public void setImplements(TypeName implement) { this.implement = implement; }
  public boolean hasDefaultType() {return defaultType != null;}
  public TypeName getDefaultType() {return defaultType;}
  public void setDefaultType(TypeName defaultType) { this.defaultType = defaultType; }

  public void accept(Visitor visitor)
  {
    ((NodeVisitor)visitor).visit(this);
  }
}
