/*
  $Id: OperatorEnum.java,v 1.5 2004/03/18 23:15:20 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.parser.node.util.operator;

import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;

public class OperatorEnum
{
  static final public OperatorEnum mulAssign = new OperatorEnum(0, "*=");
  static final public OperatorEnum divAssign = new OperatorEnum(1, "/=");
  static final public OperatorEnum addAssign = new OperatorEnum(2, "+=");
  static final public OperatorEnum subAssign = new OperatorEnum(3, "-=");
  static final public OperatorEnum modAssign = new OperatorEnum(4, "%=");
  static final public OperatorEnum powAssign = new OperatorEnum(5, "^=");
  static final public OperatorEnum assign    = new OperatorEnum(6, "=");
  static final public OperatorEnum iassign   = new OperatorEnum(7, "~");
  static final public OperatorEnum eq        = new OperatorEnum(8, "==");
  static final public OperatorEnum ieq       = new OperatorEnum(9, "~~");
  static final public OperatorEnum ne        = new OperatorEnum(10, "!=");
  static final public OperatorEnum ine       = new OperatorEnum(11, "!~");
  static final public OperatorEnum gt        = new OperatorEnum(12, ">");
  static final public OperatorEnum lt        = new OperatorEnum(13, "<");
  static final public OperatorEnum ge        = new OperatorEnum(14, ">=");
  static final public OperatorEnum le        = new OperatorEnum(15, "<=");
  static final public OperatorEnum not       = new OperatorEnum(16, "!");
  static final public OperatorEnum inc       = new OperatorEnum(17, "++");
  static final public OperatorEnum dec       = new OperatorEnum(18, "--");
  static final public OperatorEnum add       = new OperatorEnum(19, "+");
  static final public OperatorEnum sub       = new OperatorEnum(20, "-");
  static final public OperatorEnum mul       = new OperatorEnum(21, "*");
  static final public OperatorEnum div       = new OperatorEnum(22, "/");
  static final public OperatorEnum mod       = new OperatorEnum(23, "%");
  static final public OperatorEnum pow       = new OperatorEnum(24, "^");
  static final public OperatorEnum lsh       = new OperatorEnum(25, "<<");
  static final public OperatorEnum rsh       = new OperatorEnum(26, ">>");
  static final public OperatorEnum array     = new OperatorEnum(27, "[]");

  private int id;
  private String name;

  private OperatorEnum(int id, String name)
  {
    this.id = id;
    this.name = name;
  }

  public String toString()
  {
    return name;
  }
}
