/*
  $Id: MethodKindEnum.java,v 1.5 2004/03/18 23:15:20 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.symbol;

/**
 * \brief represents the kind of method possibles
 */

public class MethodKindEnum
{
  private int value;
  private String name;
  private MethodKindEnum(int value, String name)
  {
    this.value = value;
    this.name = name;
  }

  public String toString() { return name; }

  public static MethodKindEnum constructor   = new MethodKindEnum(0, "constructor");
  public static MethodKindEnum destructor    = new MethodKindEnum(1, "destructor");
  public static MethodKindEnum castOperator  = new MethodKindEnum(2, "cast");
  public static MethodKindEnum method        = new MethodKindEnum(3, "method");
  public static MethodKindEnum infix         = new MethodKindEnum(4, "infix");
  public static MethodKindEnum prefix        = new MethodKindEnum(5, "prefix");
  public static MethodKindEnum postfix       = new MethodKindEnum(6, "postfix");
  public static MethodKindEnum property      = new MethodKindEnum(7, "property");
  public static MethodKindEnum propertyArray = new MethodKindEnum(8, "property_array");
  public static MethodKindEnum initializer   = new MethodKindEnum(9, "initializer");
  public static MethodKindEnum deinitializer = new MethodKindEnum(10, "deinitializer");
}
