/*
  $Id: NullSymbolCallBackImpl.java,v 1.5 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.symbol;

import net.nosica.framework.Localizable;

import net.nosica.parser.node.util.var.TypeName;
import net.nosica.parser.node.util.var.TypeNameList;
import net.nosica.parser.node.util.var.FormalParameters;

import net.nosica.symbol.GenericType;
import net.nosica.symbol.GenericMethod;
import net.nosica.symbol.Field;
import net.nosica.symbol.SymbolCallBack;

/**
 * \brief a null implementation of symbol call back
 */
public class NullSymbolCallBackImpl implements SymbolCallBack
{
  public void onPackageDeclaration(TypeName packageName, Localizable localizable) {}
  public void onImportDeclaration(TypeName importName, Localizable localizable) {}
  public void onWrongImportDeclaration(TypeName importName, Localizable localizable) {}
  public void onDuplicateAlias(String alias, Localizable localizable) {}
  public void onClassDeclaration(GenericType type) {}
  public void onBeginNestedClassDeclaration(TypeName nestedTypeName) {}
  public void onEndNestedClassDeclaration() {}
  public void onInterfaceDeclaration(GenericType type) {}
  public void onBeginNestedInterfaceDeclaration(TypeName nestedTypeName) {}
  public void onEndNestedInterfaceDeclaration() {}
  public void onFieldDeclaration(Field field, GenericType enclosing) {}
  public void onCheckFormalParameters(FormalParameters parameters) {}
  public void onCheckThrowList(TypeNameList typeNameList) {}
  public void onConstructorDeclaration(GenericMethod method, GenericType enclosing) {}
  public void onDestructorDeclaration(GenericMethod method, GenericType enclosing) {}
  public void onCastOperatorDeclaration(GenericMethod method, GenericType enclosing) {}
  public void onOperatorDeclaration(GenericMethod method, GenericType enclosing) {}
  public void onPropertyDeclaration(GenericMethod method, GenericType enclosing) {}
  public void onMethodDeclaration(GenericMethod method, GenericType enclosing) {}
  public void onInitializer(GenericMethod method, GenericType enclosing) {}
  public void onDeinitializer(GenericMethod method, GenericType enclosing) {}
}