/*
  $Id: ResultType.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.symbol;

import net.nosica.parser.node.util.var.TypeName;

/**
 * \brief represent the result of a method
 */

public interface ResultType
{
  /**
   * \brief Return the complete type of this argument
   *
   * \return type of argument
   */
  TypeName getTypeName();

  /**
   * \brief set the typeName of this resultType
   *
   * \param typeName the new typeName
   */
  void setTypeName(TypeName typeName);

  /**
   * \brief is argument const ?
   *
   * \return true if const
   */
  boolean isConst();

  /**
   * \brief set argument as const
   */
  void setConst();

  /**
   * \brief compares this result type against another one
   *
   * \param signature the instance to compare against
   * \return true if they have the same signature
   */
  boolean hasSameSignature(ResultType signature);
}