/*
  $Id: ResultTypeImpl.java,v 1.5 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.symbol;

import net.nosica.parser.node.util.var.TypeName;

public class ResultTypeImpl implements ResultType
{
  private TypeName typeName;
  private boolean isConst;

  /**
   * Constructs a ResultType
   *
   * \param node the node where was defined the TypeName
   * \param isConst constness of this resultType
   * \param typeName typeName of resultType
   */
  public ResultTypeImpl(boolean isConst, TypeName typeName)
  {
    this.isConst = isConst;
    this.typeName = typeName;
  }

  public TypeName getTypeName() { return typeName; }
  public void setTypeName(TypeName typeName) { this.typeName = typeName; }
  public boolean isConst() { return isConst; }
  public void setConst() { this.isConst = true; }

  public boolean hasSameSignature(ResultType signature)
  {
    if (isConst() != signature.isConst())
      return false;

    return getTypeName().equals(signature.getTypeName());
  }

  public String toString()
  {
    return isConst ? "const " + typeName : typeName.toString();
  }

  public int hashCode()
  {
    return toString().hashCode();
  }
}