/*
  $Id: Symbol.java,v 1.5 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.symbol;

import net.nosica.parser.node.util.var.TypeName;

/**
 * \brief a top interface for all symbols that will be disposed in SymbolEnvironment
 */
public interface Symbol
{
  /**
   * \brief return the node in the abstract syntax tree (AST) that defines this symbol
   * This is usefull for localization and visitor pattern
   *
   * \return the node of the AST
   */
  net.nosica.parser.node.typedeclaration.Symbol getNode();

  /**
   * \brief set the localizable node
   *
   * \param symbol the new symbol
   */
  void setNode(net.nosica.parser.node.typedeclaration.Symbol symbol);

  /**
   * \brief Return the enclosing type of this symbol
   *
   * \return enclosing type
   */
  TypeName   getEnclosing();

  /**
   * \brief Set the enclosing type of type if this type is an inner or a nested type
   *
   * \param enclosing the new enclosing type
   */
  void        setEnclosing(TypeName enclosing);
}