/*
  $Id: TypeKindEnum.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.symbol;

/**
 * \brief gives type a kind : class, interface, nested or not ...
 */

public class TypeKindEnum
{
  private int value;
  private TypeKindEnum(int value) { this.value = value; }

  static public TypeKindEnum topClass        = new TypeKindEnum(0);
  static public TypeKindEnum topInterface    = new TypeKindEnum(1);
  static public TypeKindEnum nestedClass     = new TypeKindEnum(2);
  static public TypeKindEnum nestedInterface = new TypeKindEnum(3);

  public String toString()
  {
    switch (value)
    {
    case 0 : return "class ";
    case 1 : return "interface ";
    case 2 : return "nested class ";
    case 3 : return "nested interface ";
    default : throw new Error("Internal error : could not recognize TypeKind");
    }
  }
}