/*
  $Id: CommandLineOption.java,v 1.1 2004/03/18 23:15:20 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.util;

public class CommandLineOption extends AbstractCommandLineItem
{
  private String value = null;

  public CommandLineOption(CommandLineAnalysis cmd, char shortName, String longName, String description)
  {
    super(shortName, longName, description);

    cmd.addOption(this);
  }

  public CommandLineOption(CommandLineAnalysis cmd, char shortName, String longName, String description, String defaultValue)
  {
    this(cmd, shortName, longName, description);
    this.value = defaultValue;
  }

  public void setValue(String value) { this.value = value; }
  public String getValue() { return value; }
}