/*
  $Id: SettableBoolean.java,v 1.4 2004/03/04 22:16:17 djobet Exp $
  Copyright 2001-2002 David Jobet(david.jobet@free.fr) and Eric Nicolas(enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package net.nosica.util;

public class SettableBoolean
{
  private boolean value;

  public SettableBoolean(boolean value)
  {
    this.value = value;
  }

  public SettableBoolean(String s)
  {
    value = Boolean.valueOf(s).booleanValue();
  }

  public boolean equals(Object obj)
  {
    if (!(obj instanceof SettableBoolean))
      return false;

    SettableBoolean setBool = (SettableBoolean)obj;

    return value == setBool.value;
  }

  public static SettableBoolean getBoolean(String nm)
  {
    return new SettableBoolean(Boolean.getBoolean(nm));
  }

  public int hashCode()
  {
    return value ? 1 : 0;
  }

  public void setValue(boolean value)
  {
    this.value = value;
  }

  public String toString()
  {
    return new Boolean(value).toString();
  }

  public static SettableBoolean valueOf(String s)
  {
    return new SettableBoolean(s);
  }

  public boolean booleanValue()
  {
    return value;
  }
}
