/*
  $Id: utils.c,v 1.3 2004/04/29 21:28:16 djobet Exp $
  Copyright 2001-2002 David Jobet (david.jobet@free.fr) and Eric Nicolas (enicolas@dvdfr.com)
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "types.h"

char* makeCString(char* src, word32 size, char* file, int line)
{
  word32 i;
  word32 length;
  char*  result;

  length = size/4;
  result = (char*)Malloc(length+1, file, line);
  for(i=0; i<length; ++i) result[i] = src[i*4+3];
  result[length] = 0;
  return result;
}

void* mallocAndInit(word32 size, int typeCode, char* file, int line)
{
  net_nosica_lang_Object* block = (net_nosica_lang_Object*)Malloc(size, file, line);
  block->___nbRef    = 0;
  block->___rtti     = rtti + (typeCode - 1);

  return block;
}

int ___inherits(word32 childTid, word32 fatherTid)
{
  word32 *childInheritList;
  word32 index;

  if (childTid >= ___inheritDataEntries)
  {
    printf("ExHdl problem : internal error : tid list is out of bounds\n");
    exit(1);
  }

  if (childTid == fatherTid)
    return 1;

  childInheritList = ___inheritData[childTid];
  index = 0;
  while (childInheritList[index] != 0)
  {
    if (childInheritList[index] == fatherTid || ___inherits(childInheritList[index], fatherTid))
      return 1;

    ++index;
  }

  return 0;
}

___RTTI *getRTTIByTypeCode(word32 typeCode)
{
  ___RTTI *myRtti;

  myRtti = rtti;
  while (myRtti->___typeCode != 0 && myRtti->___typeCode != typeCode)
    ++myRtti;

  return myRtti;
}

___RTTI *getRTTIByName(const char *name)
{
  ___RTTI *myRtti;

  myRtti = rtti;
  while (myRtti->___typeCode != 0 && strcmp(myRtti->___name, name) != 0)
    ++myRtti;

  return myRtti;
}
