/*
  $Id: narrows.h,v 1.5 2004/03/04 22:31:51 djobet Exp $
  Copyright 2001-2002 David Jobet (david.jobet@free.fr) and Eric Nicolas (enicolas@dvdfr.com).
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language.

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Nosica standard library / native implementation ----------------------------

#ifndef _NARROWS_
#define _NARROWS_

// From INT8

word8 narrow_int8_to_word8(int8 value);
word16 narrow_int8_to_word16(int8 value);
word32 narrow_int8_to_word32(int8 value);
word64 narrow_int8_to_word64(int8 value);

// From INT16

int8 narrow_int16_to_int8(int16 value);
word8 narrow_int16_to_word8(int16 value);
word16 narrow_int16_to_word16(int16 value);
word32 narrow_int16_to_word32(int16 value);
word64 narrow_int16_to_word64(int16 value);

// From INT32

int8 narrow_int32_to_int8(int32 value);
int16 narrow_int32_to_int16(int32 value);
word8 narrow_int32_to_word8(int32 value);
word16 narrow_int32_to_word16(int32 value);
word32 narrow_int32_to_word32(int32 value);
word64 narrow_int32_to_word64(int32 value);
float32 narrow_int32_to_float32(int32 value);

// From INT64

int8 narrow_int64_to_int8(int64 value);
int16 narrow_int64_to_int16(int64 value);
int32 narrow_int64_to_int32(int64 value);
word8 narrow_int64_to_word8(int64 value);
word16 narrow_int64_to_word16(int64 value);
word32 narrow_int64_to_word32(int64 value);
word64 narrow_int64_to_word64(int64 value);
float32 narrow_int64_to_float32(int64 value);
float64 narrow_int64_to_float64(int64 value);

// From WORD8

int8 narrow_word8_to_int8(word8 value);

// From WORD16

int8 narrow_word16_to_int8(word16 value);
int16 narrow_word16_to_int16(word16 value);
word8 narrow_word16_to_word8(word16 value);

// From WORD32

int8 narrow_word32_to_int8(word32 value);
int16 narrow_word32_to_int16(word32 value);
int32 narrow_word32_to_int32(word32 value);
word8 narrow_word32_to_word8(word32 value);
word16 narrow_word32_to_word16(word32 value);
float32 narrow_word32_to_float32(word32 value);

// From WORD64

int8 narrow_word64_to_int8(word64 value);
int16 narrow_word64_to_int16(word64 value);
int32 narrow_word64_to_int32(word64 value);
int64 narrow_word64_to_int64(word64 value);
word8 narrow_word64_to_word8(word64 value);
word16 narrow_word64_to_word16(word64 value);
word32 narrow_word64_to_word32(word64 value);
float32 narrow_word64_to_float32(word64 value);
float64 narrow_word64_to_float64(word64 value);

// From FLOAT32

int8 narrow_float32_to_int8(float32 value);
int16 narrow_float32_to_int16(float32 value);
int32 narrow_float32_to_int32(float32 value);
int64 narrow_float32_to_int64(float32 value);
word8 narrow_float32_to_word8(float32 value);
word16 narrow_float32_to_word16(float32 value);
word32 narrow_float32_to_word32(float32 value);
word64 narrow_float32_to_word64(float32 value);

// From FLOAT64

int8 narrow_float64_to_int8(float64 value);
int16 narrow_float64_to_int16(float64 value);
int32 narrow_float64_to_int32(float64 value);
int64 narrow_float64_to_int64(float64 value);
word8 narrow_float64_to_word8(float64 value);
word16 narrow_float64_to_word16(float64 value);
word32 narrow_float64_to_word32(float64 value);
word64 narrow_float64_to_word64(float64 value);
float32 narrow_float64_to_float32(float64 value);

#endif // _NARROWS_
