 /*
  $Id: types0.h,v 1.6 2004/03/04 22:31:51 djobet Exp $
  Copyright 2001-2002 David Jobet (david.jobet@free.fr) and Eric Nicolas (enicolas@dvdfr.com)
  Copyright 2003-2004 David Jobet(david.jobet@free.fr).
  This file is part of Nosica, a compiler for the Nosica language

  Nosica is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Nosica is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Nosica; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Nosica standard library / native implementation ----------------------------
// $Id: types0.h,v 1.6 2004/03/04 22:31:51 djobet Exp $

#ifndef _TYPES0_
#define _TYPES0_

// --- Define all the primitive C data types

#ifdef _MSC_VER
#  include "config-msvc.h"
#else
#  ifdef __GNUC__
#    include "config-gcc.h"
#  else
#    error "Compiler not recognised. A port of Nosica is necessary"
#  endif
#endif

typedef unsigned char          bool;
typedef float                  float32;
typedef double                 float64;

#define null  0
#define false 0
#define true  1

// --- Compiler/Platform specific configuration

#ifdef WIN32
#  include "config-win32.h"
#else
#  include "config.h"
#endif

// --- Import all necessary C standard libraries

// C standard includes
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <math.h>
#ifdef HAVE_UNISTD_H
#  include <unistd.h>
#endif
#ifdef HAVE_ERRNO_H
#  include <errno.h>
#endif
#ifdef HAVE_MEMORY_H
#  include <memory.h>
#endif
#ifdef WIN32
#  define _NTSDK
#  define _WIN32_WINNT 0x0400
#  include <windows.h>
#  undef INCREF
#  undef DECREF
#endif

// ICU Unicode library
/*
#include <unicode/uchar.h>
#include <unicode/ucnv.h>
*/
#endif // _TYPES0_
