#!/usr/bin/perl -w

use strict;

## Nosica scripts -------------------------------------------------------------
## $Id: jjkeywords.pl,v 1.3 2004/03/04 22:01:21 djobet Exp $

## get file names from command line

my $fn_keywords = shift;
my $fn_reserved = shift;
my $fn_source   = shift;
my $fn_target   = shift;

## load keywords

my @keywords = ();
my @reserved = ();

open(IN, $fn_keywords) || die "could not open config file [$fn_keywords]";
while(<IN>) {
  s/^\s*//;
  s/\s*$//;
  @keywords = (@keywords, $_);
}
close(IN);

## load reserved words

open(IN, $fn_reserved) || die "could not open config file [$fn_reserved]";
while(<IN>) {
  s/^\s*//;
  s/\s*$//;
  @reserved = (@reserved, $_);
}
close(IN);

## replace @KEYWORDS@ in source to build target

open(IN, "$fn_source") || die "could not open source file [$fn_source]";
open(OUT, ">$fn_target") || die "could not create target file [$fn_target]";

my $needspace=0;
while(<IN>) {
  if (/\@KEYWORDS\@/) {

    print OUT "  /* Keywords, generated from $fn_keywords */\n";
    my $word;
    foreach $word (@keywords) { output($word); }

  } elsif (/\@RESERVED\@/) {

    print OUT "  /* Reserved words, generated from $fn_reserved */\n";
    foreach my $word (@reserved) { output($word); }

  } else {
    print OUT $_;
  }
}

close(OUT);
close(IN);

sub output {
  my $word = shift;
  my $wordUpper;
  my $aligned;
  
  if ($needspace) {
    print OUT "  | "; 
  } else { 
    print OUT "    ";
    $needspace=1;
  }

  $wordUpper = $word;
  $wordUpper =~ tr/a-z/A-Z/;

  print OUT "< ";

  $aligned = $wordUpper;
  while(length($aligned) < 20) { $aligned = $aligned . " "; }
  print OUT $aligned;

  print OUT ": ";
  $aligned = '"'.$word.'"';
  while(length($aligned) < 20) { $aligned = $aligned . " "; }
  print OUT $aligned;

  print OUT ">\n";
}
